diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/wifi-net-device.cc ns-3.44/src/wifi/model/wifi-net-device.cc
--- ns-3.43/src/wifi/model/wifi-net-device.cc	2024-10-09 16:41:10.128656900 -0700
+++ ns-3.44/src/wifi/model/wifi-net-device.cc	2025-03-09 16:55:49.803372600 -0700
@@ -49,7 +49,7 @@
                           PointerValue(),
                           MakePointerAccessor(&WifiNetDevice::GetChannel),
                           MakePointerChecker<Channel>(),
-                          TypeId::DEPRECATED,
+                          TypeId::SupportLevel::DEPRECATED,
                           "class WifiNetDevice; use the Channel "
                           "attribute of WifiPhy")
             .AddAttribute("Phy",
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/wifi-net-device.h ns-3.44/src/wifi/model/wifi-net-device.h
--- ns-3.43/src/wifi/model/wifi-net-device.h	2024-10-09 16:41:10.128656900 -0700
+++ ns-3.44/src/wifi/model/wifi-net-device.h	2025-03-09 16:55:49.803372600 -0700
@@ -32,15 +32,15 @@
 static const uint16_t MAX_MSDU_SIZE = 2304;
 
 /**
- * \defgroup wifi Wifi Models
+ * @defgroup wifi Wifi Models
  *
  * This section documents the API of the ns-3 Wifi module. For a generic functional description,
  * please refer to the ns-3 manual.
  */
 
 /**
- * \brief Hold together all Wifi-related objects.
- * \ingroup wifi
+ * @brief Hold together all Wifi-related objects.
+ * @ingroup wifi
  *
  * This class holds together ns3::Channel, ns3::WifiPhy,
  * ns3::WifiMac, and, ns3::WifiRemoteStationManager.
@@ -49,8 +49,8 @@
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
 
@@ -64,111 +64,111 @@
     /**
      * Set the Wifi standard.
      *
-     * \param standard the Wifi standard
+     * @param standard the Wifi standard
      */
     void SetStandard(WifiStandard standard);
     /**
      * Get the Wifi standard.
      *
-     * \return the Wifi standard
+     * @return the Wifi standard
      */
     WifiStandard GetStandard() const;
 
     /**
-     * \param mac the MAC layer to use.
+     * @param mac the MAC layer to use.
      */
     void SetMac(const Ptr<WifiMac> mac);
     /**
-     * \param phy the PHY layer to use.
+     * @param phy the PHY layer to use.
      */
     void SetPhy(const Ptr<WifiPhy> phy);
     /**
-     * \param phys the PHY layers to use (for 11be multi-link devices only)
+     * @param phys the PHY layers to use (for 11be multi-link devices only)
      */
     void SetPhys(const std::vector<Ptr<WifiPhy>>& phys);
     /**
-     * \param manager the manager to use.
+     * @param manager the manager to use.
      */
     void SetRemoteStationManager(const Ptr<WifiRemoteStationManager> manager);
     /**
-     * \param managers the managers to use (for 11be multi-link devices only)
+     * @param managers the managers to use (for 11be multi-link devices only)
      */
     void SetRemoteStationManagers(const std::vector<Ptr<WifiRemoteStationManager>>& managers);
     /**
-     * \returns the MAC we are currently using.
+     * @returns the MAC we are currently using.
      */
     Ptr<WifiMac> GetMac() const;
     /**
-     * \returns the PHY we are currently using.
+     * @returns the PHY we are currently using.
      *
      * This GetPhy variant is needed to keep using "Phy" in the path names.
      */
     Ptr<WifiPhy> GetPhy() const;
     /**
-     * \param i the index (starting at 0) of the PHY object to retrieve
-     * \returns the requested PHY object
+     * @param i the index (starting at 0) of the PHY object to retrieve
+     * @returns the requested PHY object
      */
     virtual Ptr<WifiPhy> GetPhy(uint8_t i) const;
     /**
-     * \returns a const reference to the vector of PHY objects
+     * @returns a const reference to the vector of PHY objects
      */
     virtual const std::vector<Ptr<WifiPhy>>& GetPhys() const;
     /**
-     * \returns the number of PHY objects
+     * @returns the number of PHY objects
      */
     uint8_t GetNPhys() const;
     /**
-     * \returns the remote station manager we are currently using.
+     * @returns the remote station manager we are currently using.
      *
      * This GetRemoteStationManager variant is needed to keep using "RemoteStationManager"
      * in the path names.
      */
     Ptr<WifiRemoteStationManager> GetRemoteStationManager() const;
     /**
-     * \param linkId the ID (starting at 0) of the link of the RemoteStationManager
+     * @param linkId the ID (starting at 0) of the link of the RemoteStationManager
      *               object to retrieve
-     * \returns the requested remote station manager
+     * @returns the requested remote station manager
      */
     Ptr<WifiRemoteStationManager> GetRemoteStationManager(uint8_t linkId) const;
     /**
-     * \returns a const reference to the vector of remote station managers
+     * @returns a const reference to the vector of remote station managers
      */
     virtual const std::vector<Ptr<WifiRemoteStationManager>>& GetRemoteStationManagers() const;
     /**
-     * \returns the number of remote station managers
+     * @returns the number of remote station managers
      */
     uint8_t GetNRemoteStationManagers() const;
 
     /**
-     * \param htConfiguration pointer to HtConfiguration
+     * @param htConfiguration pointer to HtConfiguration
      */
     void SetHtConfiguration(Ptr<HtConfiguration> htConfiguration);
     /**
-     * \return pointer to HtConfiguration if it exists
+     * @return pointer to HtConfiguration if it exists
      */
     Ptr<HtConfiguration> GetHtConfiguration() const;
     /**
-     * \param vhtConfiguration pointer to VhtConfiguration
+     * @param vhtConfiguration pointer to VhtConfiguration
      */
     void SetVhtConfiguration(Ptr<VhtConfiguration> vhtConfiguration);
     /**
-     * \return pointer to VhtConfiguration if it exists
+     * @return pointer to VhtConfiguration if it exists
      */
     Ptr<VhtConfiguration> GetVhtConfiguration() const;
     /**
-     * \param heConfiguration pointer to HeConfiguration
+     * @param heConfiguration pointer to HeConfiguration
      */
     void SetHeConfiguration(Ptr<HeConfiguration> heConfiguration);
     /**
-     * \return pointer to HeConfiguration if it exists
+     * @return pointer to HeConfiguration if it exists
      */
     Ptr<HeConfiguration> GetHeConfiguration() const;
     /**
-     * \param ehtConfiguration pointer to EhtConfiguration
+     * @param ehtConfiguration pointer to EhtConfiguration
      */
     void SetEhtConfiguration(Ptr<EhtConfiguration> ehtConfiguration);
     /**
-     * \return pointer to EhtConfiguration if it exists
+     * @return pointer to EhtConfiguration if it exists
      */
     Ptr<EhtConfiguration> GetEhtConfiguration() const;
 
@@ -207,9 +207,9 @@
      * Receive a packet from the lower layer and pass the
      * packet up the stack.
      *
-     * \param packet the packet to forward up
-     * \param from the source address
-     * \param to the destination address
+     * @param packet the packet to forward up
+     * @param from the source address
+     * @param to the destination address
      */
     void ForwardUp(Ptr<const Packet> packet, Mac48Address from, Mac48Address to);
 
@@ -232,11 +232,11 @@
     /**
      * Send a packet
      *
-     * \param packet packet sent from upper layers
-     * \param source source mac address (if provided)
-     * \param dest destination mac address
-     * \param protocolNumber type of payload contained in this packet
-     * \returns true if successful, false otherwise
+     * @param packet packet sent from upper layers
+     * @param source source mac address (if provided)
+     * @param dest destination mac address
+     * @param protocolNumber type of payload contained in this packet
+     * @returns true if successful, false otherwise
      */
     bool DoSend(Ptr<Packet> packet,
                 std::optional<Address> source,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/wifi-opt-field.h ns-3.44/src/wifi/model/wifi-opt-field.h
--- ns-3.43/src/wifi/model/wifi-opt-field.h	2024-10-09 16:41:10.128656900 -0700
+++ ns-3.44/src/wifi/model/wifi-opt-field.h	2025-03-09 16:55:49.803372600 -0700
@@ -16,7 +16,7 @@
 {
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  *
  * OptFieldWithPresenceInd is a class modeling an optional field (in an Information Element, a
  * management frame, etc.) having an associated Presence Indicator bit. This class is a wrapper
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/wifi-phy-band.h ns-3.44/src/wifi/model/wifi-phy-band.h
--- ns-3.43/src/wifi/model/wifi-phy-band.h	2024-10-09 16:41:10.132656800 -0700
+++ ns-3.44/src/wifi/model/wifi-phy-band.h	2025-03-09 16:55:49.803372600 -0700
@@ -15,7 +15,7 @@
 {
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  * Identifies the PHY band.
  */
 enum WifiPhyBand
@@ -33,11 +33,11 @@
 };
 
 /**
- * \brief Stream insertion operator.
+ * @brief Stream insertion operator.
  *
- * \param os the stream
- * \param band the band
- * \returns a reference to the stream
+ * @param os the stream
+ * @param band the band
+ * @returns a reference to the stream
  */
 inline std::ostream&
 operator<<(std::ostream& os, WifiPhyBand band)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/wifi-phy.cc ns-3.44/src/wifi/model/wifi-phy.cc
--- ns-3.43/src/wifi/model/wifi-phy.cc	2024-10-09 16:41:10.132656800 -0700
+++ ns-3.44/src/wifi/model/wifi-phy.cc	2025-03-09 16:55:49.803372600 -0700
@@ -299,16 +299,22 @@
                           BooleanValue(false),
                           MakeBooleanAccessor(&WifiPhy::m_notifyRxMacHeaderEnd),
                           MakeBooleanChecker())
-            .AddTraceSource("PhyTxBegin",
-                            "Trace source indicating a packet "
-                            "has begun transmitting over the channel medium",
-                            MakeTraceSourceAccessor(&WifiPhy::m_phyTxBeginTrace),
-                            "ns3::WifiPhy::PhyTxBeginTracedCallback")
-            .AddTraceSource("PhyTxPsduBegin",
-                            "Trace source indicating a PSDU "
-                            "has begun transmitting over the channel medium",
-                            MakeTraceSourceAccessor(&WifiPhy::m_phyTxPsduBeginTrace),
-                            "ns3::WifiPhy::PsduTxBeginCallback")
+            .AddTraceSource(
+                "PhyTxBegin",
+                "Trace source indicating a packet has begun transmitting over the medium; "
+                "the packet holds a single MPDU even if the MPDU is transmitted within an A-MPDU "
+                "(in which case this trace fires for each MPDU in the "
+                "A-MPDU).",
+                MakeTraceSourceAccessor(&WifiPhy::m_phyTxBeginTrace),
+                "ns3::WifiPhy::PhyTxBeginTracedCallback")
+            .AddTraceSource(
+                "PhyTxPsduBegin",
+                "Trace source indicating a PSDU has begun transmitting over the channel medium; "
+                "this trace returns a WifiConstPsduMap with a single element (in the case of SU "
+                "PPDU) "
+                "or multiple elements (in the case of MU PPDU)",
+                MakeTraceSourceAccessor(&WifiPhy::m_phyTxPsduBeginTrace),
+                "ns3::WifiPhy::PsduTxBeginCallback")
             .AddTraceSource("PhyTxEnd",
                             "Trace source indicating a packet "
                             "has been completely transmitted over the channel.",
@@ -345,7 +351,7 @@
                             "Trace source indicating a packet "
                             "has been dropped by the device during reception",
                             MakeTraceSourceAccessor(&WifiPhy::m_phyRxDropTrace),
-                            "ns3::Packet::TracedCallback")
+                            "ns3::WifiPhy::PhyRxDropTracedCallback")
             .AddTraceSource("PhyRxPpduDrop",
                             "Trace source indicating a ppdu "
                             "has been dropped by the device during reception",
@@ -379,17 +385,17 @@
       m_standard(WIFI_STANDARD_UNSPECIFIED),
       m_maxModClassSupported(WIFI_MOD_CLASS_UNKNOWN),
       m_band(WIFI_PHY_BAND_UNSPECIFIED),
-      m_sifs(Seconds(0)),
-      m_slot(Seconds(0)),
-      m_pifs(Seconds(0)),
-      m_ackTxTime(Seconds(0)),
-      m_blockAckTxTime(Seconds(0)),
+      m_sifs(),
+      m_slot(),
+      m_pifs(),
+      m_ackTxTime(),
+      m_blockAckTxTime(),
       m_powerRestricted(false),
       m_channelAccessRequested(false),
       m_txSpatialStreams(1),
       m_rxSpatialStreams(1),
       m_wifiRadioEnergyModel(nullptr),
-      m_timeLastPreambleDetected(Seconds(0))
+      m_timeLastPreambleDetected()
 {
     NS_LOG_FUNCTION(this);
     m_random = CreateObject<UniformRandomVariable>();
@@ -718,7 +724,7 @@
     dBm_u dbm;
     if (m_nTxPower > 1)
     {
-        dbm = m_txPowerBase + powerLevel * (m_txPowerEnd - m_txPowerBase) / (m_nTxPower - 1);
+        dbm = m_txPowerBase + dB_u{powerLevel * (m_txPowerEnd - m_txPowerBase) / (m_nTxPower - 1)};
     }
     else
     {
@@ -910,7 +916,7 @@
 WifiPhy::Configure80211p()
 {
     NS_LOG_FUNCTION(this);
-    if (GetChannelWidth() == 10)
+    if (GetChannelWidth() == MHz_u{10})
     {
         AddPhyEntity(WIFI_MOD_CLASS_OFDM, Create<OfdmPhy>(OFDM_PHY_10_MHZ));
 
@@ -920,7 +926,7 @@
         SetPifs(GetSifs() + GetSlot());
         m_ackTxTime = MicroSeconds(88);
     }
-    else if (GetChannelWidth() == 5)
+    else if (GetChannelWidth() == MHz_u{5})
     {
         AddPhyEntity(WIFI_MOD_CLASS_OFDM, Create<OfdmPhy>(OFDM_PHY_5_MHZ));
 
@@ -1098,7 +1104,7 @@
 uint8_t
 WifiPhy::GetPrimary20Index() const
 {
-    return m_operatingChannel.GetPrimaryChannelIndex(20);
+    return m_operatingChannel.GetPrimaryChannelIndex(MHz_u{20});
 }
 
 void
@@ -1119,7 +1125,7 @@
     auto modulation = mode.GetModulationClass();
     if (modulation == WIFI_MOD_CLASS_DSSS || modulation == WIFI_MOD_CLASS_HR_DSSS)
     {
-        return 22;
+        return MHz_u{22};
     }
 
     return std::min({GetChannelWidth(), GetMaximumChannelWidth(modulation), maxAllowedWidth});
@@ -1135,7 +1141,7 @@
         segments.emplace_back(channel.GetNumber(segmentId),
                               channel.GetWidth(segmentId),
                               channel.GetPhyBand(),
-                              channel.GetPrimaryChannelIndex(20));
+                              channel.GetPrimaryChannelIndex(MHz_u{20}));
     }
     SetOperatingChannel(segments);
 }
@@ -1240,7 +1246,7 @@
         {
             band = GetDefaultPhyBand(m_standard);
         }
-        if (width == 0 && number == 0)
+        if (width == MHz_u{0} && number == 0)
         {
             width = GetDefaultChannelWidth(m_standard, static_cast<WifiPhyBand>(band));
         }
@@ -1273,7 +1279,7 @@
                    std::back_inserter(segments),
                    [this](const auto& channelTuple) {
                        return FrequencyChannelInfo{std::get<0>(channelTuple),
-                                                   0,
+                                                   MHz_u{0},
                                                    std::get<1>(channelTuple),
                                                    m_band};
                    });
@@ -1286,7 +1292,7 @@
     if (m_device)
     {
         if (auto htConfig = m_device->GetHtConfiguration();
-            htConfig && !htConfig->Get40MHzOperationSupported() && chWidth > 20)
+            htConfig && !htConfig->m_40MHzSupported && chWidth > MHz_u{20})
         {
             NS_ABORT_MSG("Attempting to set a " << chWidth
                                                 << " MHz channel on"
@@ -1294,7 +1300,7 @@
         }
 
         if (auto vhtConfig = m_device->GetVhtConfiguration();
-            vhtConfig && !vhtConfig->Get160MHzOperationSupported() && chWidth > 80)
+            vhtConfig && !vhtConfig->m_160MHzSupported && chWidth > MHz_u{80})
         {
             NS_ABORT_MSG("Attempting to set a " << chWidth
                                                 << " MHz channel on"
@@ -1408,7 +1414,7 @@
 }
 
 void
-WifiPhy::SetSleepMode()
+WifiPhy::SetSleepMode(bool forceSleepInRx)
 {
     NS_LOG_FUNCTION(this);
     m_powerRestricted = false;
@@ -1417,15 +1423,24 @@
     {
     case WifiPhyState::TX:
         NS_LOG_DEBUG("setting sleep mode postponed until end of current transmission");
-        Simulator::Schedule(GetDelayUntilIdle(), &WifiPhy::SetSleepMode, this);
+        Simulator::Schedule(GetDelayUntilIdle(), &WifiPhy::SetSleepMode, this, forceSleepInRx);
         break;
     case WifiPhyState::RX:
-        NS_LOG_DEBUG("setting sleep mode postponed until end of current reception");
-        Simulator::Schedule(GetDelayUntilIdle(), &WifiPhy::SetSleepMode, this);
+        NS_LOG_DEBUG("setting sleep mode"
+                     << (forceSleepInRx ? "" : "postponed until end of current reception"));
+        if (forceSleepInRx)
+        {
+            AbortCurrentReception(WifiPhyRxfailureReason::SLEEPING);
+            m_state->SwitchToSleep();
+        }
+        else
+        {
+            Simulator::Schedule(GetDelayUntilIdle(), &WifiPhy::SetSleepMode, this, forceSleepInRx);
+        }
         break;
     case WifiPhyState::SWITCHING:
         NS_LOG_DEBUG("setting sleep mode postponed until end of channel switching");
-        Simulator::Schedule(GetDelayUntilIdle(), &WifiPhy::SetSleepMode, this);
+        Simulator::Schedule(GetDelayUntilIdle(), &WifiPhy::SetSleepMode, this, forceSleepInRx);
         break;
     case WifiPhyState::CCA_BUSY:
     case WifiPhyState::IDLE:
@@ -1691,9 +1706,9 @@
 void
 WifiPhy::NotifyMonitorSniffRx(Ptr<const WifiPsdu> psdu,
                               MHz_u channelFreq,
-                              WifiTxVector txVector,
+                              const WifiTxVector& txVector,
                               SignalNoiseDbm signalNoise,
-                              std::vector<bool> statusPerMpdu,
+                              const std::vector<bool>& statusPerMpdu,
                               uint16_t staId)
 {
     MpduInfo aMpdu;
@@ -1745,7 +1760,7 @@
 void
 WifiPhy::NotifyMonitorSniffTx(Ptr<const WifiPsdu> psdu,
                               MHz_u channelFreq,
-                              WifiTxVector txVector,
+                              const WifiTxVector& txVector,
                               uint16_t staId)
 {
     MpduInfo aMpdu;
@@ -1782,6 +1797,19 @@
     }
 }
 
+std::optional<Time>
+WifiPhy::GetTimeToMacHdrEnd(uint16_t staId) const
+{
+    for (auto& [modClass, phyEntity] : m_phyEntities)
+    {
+        if (auto remTime = phyEntity->GetTimeToMacHdrEnd(staId))
+        {
+            return remTime;
+        }
+    }
+    return std::nullopt;
+}
+
 WifiConstPsduMap
 WifiPhy::GetWifiConstPsduMap(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector)
 {
@@ -1982,10 +2010,15 @@
     }
 }
 
-bool
-WifiPhy::IsReceivingPhyHeader() const
+std::optional<std::reference_wrapper<const WifiTxVector>>
+WifiPhy::GetInfoIfRxingPhyHeader() const
 {
-    return m_endPhyRxEvent.IsPending();
+    if (m_endPhyRxEvent.IsPending())
+    {
+        NS_ASSERT_MSG(m_currentEvent, "No current event while receiving PHY header");
+        return std::cref(m_currentEvent->GetPpdu()->GetTxVector());
+    }
+    return std::nullopt;
 }
 
 void
@@ -2353,7 +2386,7 @@
 Hz_u
 WifiPhy::GetSubcarrierSpacing() const
 {
-    Hz_u subcarrierSpacing = 0;
+    Hz_u subcarrierSpacing{0};
     switch (GetStandard())
     {
     case WIFI_STANDARD_80211a:
@@ -2361,21 +2394,21 @@
     case WIFI_STANDARD_80211b:
     case WIFI_STANDARD_80211n:
     case WIFI_STANDARD_80211ac:
-        subcarrierSpacing = 312500;
+        subcarrierSpacing = Hz_u{312500};
         break;
     case WIFI_STANDARD_80211p:
-        if (GetChannelWidth() == 5)
+        if (GetChannelWidth() == MHz_u{5})
         {
-            subcarrierSpacing = 78125;
+            subcarrierSpacing = Hz_u{78125};
         }
         else
         {
-            subcarrierSpacing = 156250;
+            subcarrierSpacing = Hz_u{156250};
         }
         break;
     case WIFI_STANDARD_80211ax:
     case WIFI_STANDARD_80211be:
-        subcarrierSpacing = 78125;
+        subcarrierSpacing = Hz_u{78125};
         break;
     default:
         NS_FATAL_ERROR("Standard unknown: " << GetStandard());
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/wifi-phy-common.cc ns-3.44/src/wifi/model/wifi-phy-common.cc
--- ns-3.43/src/wifi/model/wifi-phy-common.cc	2024-10-09 16:41:10.132656800 -0700
+++ ns-3.44/src/wifi/model/wifi-phy-common.cc	2025-03-09 16:55:49.803372600 -0700
@@ -34,7 +34,7 @@
         Ptr<HtConfiguration> htConfiguration = device->GetHtConfiguration();
         NS_ASSERT(htConfiguration); // If HT/VHT modulation is used, we should have a HT
                                     // configuration attached
-        gi = NanoSeconds(htConfiguration->GetShortGuardIntervalSupported() ? 400 : 800);
+        gi = NanoSeconds(htConfiguration->m_sgiSupported ? 400 : 800);
     }
     return gi;
 }
@@ -56,7 +56,7 @@
 }
 
 WifiPreamble
-GetPreambleForTransmission(WifiModulationClass modulation, bool useShortPreamble)
+GetPreambleForTransmission(WifiModulationClass modulation, bool useShortPreamble /* = false */)
 {
     if (modulation == WIFI_MOD_CLASS_EHT)
     {
@@ -239,22 +239,23 @@
     {
     case WIFI_MOD_CLASS_DSSS:
     case WIFI_MOD_CLASS_HR_DSSS:
-        return 22;
+        return MHz_u{22};
     case WIFI_MOD_CLASS_OFDM:
     case WIFI_MOD_CLASS_ERP_OFDM:
-        return 20;
+        return MHz_u{20};
     case WIFI_MOD_CLASS_HT:
-        return 40;
+        return MHz_u{40};
     // NOLINTBEGIN(bugprone-branch-clone)
     case WIFI_MOD_CLASS_VHT:
     case WIFI_MOD_CLASS_HE:
-        return 160;
+        return MHz_u{160};
     case WIFI_MOD_CLASS_EHT:
-        return 160; // TODO update when 320 MHz channels are supported and remove clang-tidy guards
+        return MHz_u{
+            160}; // TODO update when 320 MHz channels are supported and remove clang-tidy guards
     // NOLINTEND(bugprone-branch-clone)
     default:
         NS_ABORT_MSG("Unknown modulation class: " << modulation);
-        return 0;
+        return MHz_u{0};
     }
 }
 
@@ -264,27 +265,27 @@
     switch (width)
     {
     case WifiChannelWidthType::UNKNOWN:
-        return 0;
+        return MHz_u{0};
     case WifiChannelWidthType::CW_20MHZ:
-        return 20;
+        return MHz_u{20};
     case WifiChannelWidthType::CW_22MHZ:
-        return 22;
+        return MHz_u{22};
     case WifiChannelWidthType::CW_5MHZ:
-        return 5;
+        return MHz_u{5};
     case WifiChannelWidthType::CW_10MHZ:
-        return 10;
+        return MHz_u{10};
     case WifiChannelWidthType::CW_40MHZ:
-        return 40;
+        return MHz_u{40};
     case WifiChannelWidthType::CW_80MHZ:
-        return 80;
+        return MHz_u{80};
     case WifiChannelWidthType::CW_160MHZ:
     case WifiChannelWidthType::CW_80_PLUS_80MHZ:
-        return 160;
+        return MHz_u{160};
     case WifiChannelWidthType::CW_2160MHZ:
-        return 2160;
+        return MHz_u{2160};
     default:
         NS_FATAL_ERROR("Unknown wifi channel width type " << width);
-        return 0;
+        return MHz_u{0};
     }
 }
 
